\chapter{Kernel Components}
\label{chap:kernel-components}

The kernel is split into many components, reaching from standalone modules such as linked lists to tightly connected modules like scheduling and events. The modularity of the kernel should allow for the replacement of existing components and provide a structure to add new features.

%-------------------------------------------------------------------------------
\section{Process \& Thread}

A thread or sometimes called task in embedded software represents an entity of work. It has an entry function that typically contains an infinite loop. A thread either runs periodically (isochronous) or an event triggers processing (asynchronous). On an embedded system, threads spend most of their time waiting for a specific time or an event. The main benefit of using an RTOS for a user comes from the separation of work into scalable units and a unified communication system between them. One or more threads and a memory region together form a process.

%...............................................................................
\subsection{Design}

Bern RTOS uses a parallelism abstraction known from computers: processes and threads. Running on the RTOS are at least one process each contains one or more threads. However, there are some differences from a general purpose operating system (GPOS). Similar to GPOS processes are isolated from each other, but there is are no virtual addresses on a microcontroller. All memory and peripherals are mapped into one continuous address space. Also, on a GPOS, processes are started individually, while on Bern RTOS, all processes are compiled at the same time and linked into one image.

\begin{figure}[htb!]
    \centering
    \includegraphics{rtos-proc-thread.pdf}
    \caption[Resource organization with process and thread tables in the kernel.]{Resource organization with process and thread tables in the kernel \cite[109]{tanenbaum_bos_2015}.}
    \label{fig:layout-proc-thread}
\end{figure}

Processes and management structures are separated in Bern RTOS. \autoref{fig:layout-proc-thread} shows threads running within processes in user mode. The accompanying management structures (process and thread table) are stored in kernel memory.

\begin{figure}[htb!]
    \centering
    \includegraphics{mem-map-overview.pdf}
    \caption{Memory accessible from Thread Y.}
    \label{fig:mem-map-overview}
\end{figure}

The separation of process memory is illustrated as a memory map in \autoref{fig:mem-map-overview}. Every process and the kernel have their own block of memory for data. The CPU starts on the main stack, which is later used for the kernel and cannot be accessed by processes anymore. The memory size of a process is defined at compile time. In the example of process B there is some static data placed in process memory. The rest is automatically available to the process allocator. Thread stacks can be allocated using a process allocator. Each stack will have an overflow barrier to prevent the corruption of data from a stack overflow.

A thread can access data on its own stack as well as stacks of threads of the same process. Globally shared data and static data within the process are also accessible. However, a thread will be terminated if it attempts to read or modify data on the main stack, the kernel memory, or any other process. Zephyrs usermode memory domain \cite{linux:zephyr} inspired the behavior of the process memory.

In most RTOS, a thread can access anything in RAM, including the thread/task control blocks (TCB) \cite[~113]{labrosse_2009}. The TCB contains the state of a thread, including the priority. For an RTOS to be secure, control structures such as the TCB must be inaccessible to threads, such that priorities for example cannot be directly changed.

\begin{figure}[htb!]
    \centering
    \includegraphics{thread-memory.pdf}
    \caption{Thread stack and control block.}
    \label{fig:thread-memory}
\end{figure}

As shown in \autoref{fig:thread-memory} a thread can access its own stack. Only the kernel stores and accesses the thread control block, called \mintinline{rust}{Thread} in Bern RTOS. The \mintinline{rust}{Thread} structure contains owning pointers to the stack, privilege information including priority and memory access configuration, as well as transitions and wake-up times used by the schedulers finite state machine.

The fields of the \mintinline{rust}{Thread} structure can never be directly accessed; they are set via system calls, e.g., \mintinline{rust}{bern_kernel::sleep()}, \mintinline{rust}{bern_kernel::thread_exit()}, \mintinline{rust}{mutex.lock(100)}. It is the responsibility of the kernel to validate system calls before executing them. There are no thread handles at the moment, thus threads can only change their own state.

\begin{figure}[htb!]
    \centering
    \includegraphics{thread-stack.pdf}
    \caption{Thread stack frame.}
    \label{fig:thread-stack}
\end{figure}

Threads in Bern RTOS are spawned using closures (see usage subsection). A closure can capture its environment, which is placed on the main stack. The closure will generate an anonymous structure without memory layout guaranties \cite{rust:type-layout}. Because the thread will not be able to access the main stack, the data structure must be moved to the thread stack — \circled{1} in \autoref{fig:thread-stack}. Every closure will have a different type, to launch a generic type a trait object \circled{2} is used. A trait object in Rust consists of a fat pointer pointing to a data structure and to methods (vtable) \cite{blandy_orendorff_2017}. The closure can now be entered through the trait object without the use of generic types, performed in the \mintinline{rust}{entry()} function.

Data alignment must be considered when copying data manually to a stack \circled{3}. On an Arm Cortex-M CPU (Armv7E-M) for example, the compiler will optimize the fetch operation of the trait object (two 32bit addresses) to a single load double-word instruction (\mintinline{asm}{ldrd}, \cite[135]{yiu_beckmann_2014}).

Below the closure starts the usable part of the thread stack \circled{4}. At thread creation, the initial register values will put the stack. These include a program counter at the \mintinline{rust}{entry()} function with the trait object loaded as a parameter in the registers \circled{5}. For the kernel, starting a thread is equal to continuing a previously running thread, it will switch the stack and pop the registers.

After some time the stack will contain locally stacked variables and when being paused the current set of registers \circled{6}. If a thread is to attempt to grow the stack below the bottom mark, an exception will call the kernel to deal with the issue.

%...............................................................................
\subsection{Usage}

Creating a thread follows the build pattern in the way \mintinline{rust}{freertos-rust} does \cite{github:freertos-rust}. The thread builder can take any settings regarding a new thread. The kernel initialized the thread and stack, partially because only the kernel can access the stack for the new thread. The builder pattern also allows running threads to spawn new threads.

\begin{customlisting}
\begin{minted}[escapeinside='']{rust}
static PROC: &Process = bern_kernel::new_process!(my_process'\circled{1}', 8192);
#[link_section=".process.my_process"]'\circled{2}'
static mut MY_BUFFER: [u8; 16] = [0; 16];
#[entry]
fn main() -> ! {
    let mut board = Board::new();
    board.led.set_high();

    bern_kernel::kernel::init();'\circled{3}'
    bern_kernel::time::set_tick_frequency(
        1.kHz(),
        board.sysclock().Hz()
    );

    let mut led = board.led;
    PROC.init(move |c| {'\circled{4}'
        Thread::new(c)'\circled{5}'
            .priority(Priority::new(0))'\circled{6}'
            .stack(Stack::try_new_in(c, 1024).unwrap()'\circled{7}')
            .spawn(move || '\circled{8}'{
                loop {
                    led.set_high();'\circled{9}'
                    bern_kernel::sleep(250);
                    led.set_low();
                    bern_kernel::sleep(750);'\circled{10}'
                }
            });
    }).unwrap();

    bern_kernel::start();'\circled{11}'
}
\end{minted}
\caption{Creating a new thread.}
\label{lst:thread-spawn}
\end{customlisting}

The macro at \circled{1} in \autoref{lst:thread-spawn} defines processes statically. The macro generates a linker section with the name given and checks the size requirements of the process memory. For example, on the Armv7E-M memory protection unit, a memory region must have a $2^n$ size and alignment. By defining processes at compile time, the linker can place the memory blocks with minimal memory waste.

Any static data can be placed in the process memory by specifying the memory section \circled{2}. If no link section is defined the static data are placed in the global shared section that all threads can access.

Before any kernel function call, we must initialize the scheduler \circled{3} and set the tick frequency. Threads can only be spawned in the process context \circled{4}. A thread builder is created by calling \circled{5}. Now, the default priority can be changed \circled{6} and a stack can be allocated for the thread \circled{7}. Note that thread priorities are global for all threads from all processes. There are no process priorities.

Lastly, the \mintinline{rust}{spawn()} call consumes the builder and takes the thread entry point as a closure. The closure captures \circled{8} the environment, i.e., takes \mintinline{rust}{led}. A typical thread contains an infinite loop, in this case an LED \circled{9} is toggled. A running thread can call static functions of the kernel \circled{10} as the scheduler will always know which thread is running. At last the scheduler is started at \circled{11}.

Because a closure can capture its environment, parameters are passed to the thread with type information, no casting of pointers is necessary. Moving captured variables to threads enables the compiler to check ownership and multi-threaded access. The compiler would for example return an error if \mintinline{rust}{led} where to be used after \circled{9}.

\begin{customlisting}
\begin{minted}[escapeinside='']{rust}
Thread::new(c)
    .idle_thread()'\circled{1}'
    .static_stack(Stack::try_new_in(c, 512).unwrap()))
    .spawn(move || {
        loop {
            cortex_m::asm::nop();
        }
    });
\end{minted}
\caption{Replacing the default idle thread.}
\label{lst:thread-idle}
\end{customlisting}

To change the behavior when all threads are suspended, the default thread can be replaced \circled{1} in \autoref{lst:thread-idle}. The idle thread is a normal thread, but with the lowest possible priority. An idle thread must never exit, as this would crash the kernel.

%-------------------------------------------------------------------------------
\section{Interrupts}

Hardware events can generate interrupts on the CPU. Processing events asynchronically is more efficient and introduces less latency than constantly polling a hardware resource. Not only does the efficiency improvement provide more processing power to other tasks, it also greatly reduces power consumption on low power systems by entering sleep mode when the CPU is inactive. 

%...............................................................................
\subsection{Design}

Usually, an interrupt service routing (ISR) has a specific function name replacing a weak symbol in the interrupt vector table at link time. As soon as the corresponding interrupt request (IRQ) is issued by the hardware, the CPU jumps to the ISR.

\begin{figure}[H]
    \centering
    \includegraphics{interrupts.pdf}
    \caption{Overview of kernel interrupt handling.}
    \label{fig:interrupt-overview}
\end{figure}

As illustrated in \autoref{fig:interrupt-overview} an IRQ triggers the ISR handler within the kernel. Then, the kernel calls the ISR registered by the user. The user can then pass a signal or data to a thread for further processing.

If an interrupt handler does not interact with the kernel or a thread, it can still be declared in the interrupt vector table. However, if the custom ISR exists in the vector table, the kernel ISR handler will not be called anymore.

\begin{figure}[htb!]
    \centering
    \includegraphics{interrupt-seq.pdf}
    \caption{Interrupt handler sequence diagram.}
    \label{fig:interrupt-seq}
\end{figure}

The diagram in \autoref{fig:interrupt-seq} details the setup and the IRQ call sequence. At startup the user creates and registers a new ISR handler at kernel. When the IRQ occurs, the kernel ISR is called. With the IRQ number, the kernel selects which user ISRs to call. If there are multiple ISR handlers for one IRQ, they will be called in sequence. The user handler can then do some short work such as clearing flags or passing new data to a thread. The ISR is then exited and the kernel checks if a context switch is necessary. If a thread is awaiting an event, it can the process incoming data.

The goal is to keep interrupts short and to defer heavy work from ISRs to threads for multiple reasons. First, even the lowest interrupt priority is higher than any thread priority. A low priority interrupt might unnecessarily block a high priority thread. Secondly, interrupts run in kernel mode with the same privileges as the kernel. Fewer lines of code in kernel mode reduce the probability of a software defect. Also, keep in mind that the ISR is executed on the kernel stack.

\notebox{
    Strict memory boundaries could be enforced if all interrupt handling was defferd to thread mode. An issue arises when an interrupt must be cleared in a microcontroller register the kernel does not know about. If the kernel were to exit the ISR without clearing the register, the handler would be called again resulting a deadlock. As a solution, the kernel could deactivate the interrupt until the user ISR processes it. This might lead to missed interrupts, which is to be avoided as well.
}

%...............................................................................
\subsection{Usage}

Setting up an interrupt handler follows the concept of the thread builder.

\begin{customlisting}
\begin{minted}[escapeinside='']{rust}
static PROC: &Process = bern_kernel::new_process!(my_process, 8192);
#[entry]
fn main() -> ! {
    // init 
    PROC.init(move |c| {
        InterruptHandler::new(c)'\circled{1}'
            .stack(InterruptStack::Kernel)'\circled{2}'
            .connect_interrupt(stm32f4xx_hal::interrupt::EXTI15_10 as u16)'\circled{3}'
            .handler(move |_c| {'\circled{4}'
                // clear IRQ flags
                // send events to threads
            });

        /*..*/
    }).unwrap();
    /*..*/
}
\end{minted}
\caption{Creating a new interrupt handler.}
\label{lst:interrutp-handler}
\end{customlisting}

Similar to spawning a thread, an interrupt handler is set up within a process context \circled{1} in \autoref{lst:interrutp-handler}. Currently, an interrupt handler can only run on the kernel stack \circled{2}. The handler is connected to an IRQ using the interrupt index \circled{3}. An interrupt handler can be connected to multiple IRQs. alternatively, on IRQ can trigger multiple interrupt handlers. This is useful as some interrupts combine signal (i.e. multiple GPIOs trigger one IRQ) or one peripheral has multiple IRQs (i.e. an UART has multiple TX and RX interrupts that can be processed in one handler).

Lastly, the handler code is placed in a closure \circled{4}. Using a closure again can capture its environment. Therefore, synchronization primitives and channels can be passed to an interrupt handler. In contrast to a static ISR a closure can guarantee that a synchronization object is initialized before its used for the first time. The handler itself should only clear IRQ flags if necessary and send data or signals to a thread. Processing data is meant to be done in threads.  

Note that the example excludes enabling the interrupt on microcontroller and interrupt controller level. It is up to the user to activate the interrupt. The kernel only handles interrupt calls.
    
%-------------------------------------------------------------------------------
\section{Scheduler}

The scheduler is the kernels core component. It manages thread states and handles most system calls from threads.

%...............................................................................
\subsection{Scheduling}

The goal of scheduling is to execute time-critical threads before the deadline and to share the CPU between multiple threads, so that no thread ever starves. When the scheduler decides to run another thread, the CPU context is switched, leading to overhead. Context switch overhead is the biggest downside of an RTOS and must be minimized.

\subsubsection{Preemptive}

Whenever an interrupt is triggered on a microcontroller, the main program is preempted and the ISR is executed. The main program resumes afterwards. A preemptive scheduler does the same, but with threads.

\begin{figure}[H]
    \centering
    \subfile{images/sched-preempt.tex}
    \caption{Priority based preemptive scheduling.}
    \label{fig:preempt}
\end{figure}

In \autoref{fig:preempt} an interrupt \circled{1} updates a resource T2 has been waiting for. Because T2 has a higher priority than the running thread T1, the scheduler will switch thread contexts and execute T2 instead \circled{2}. After T2 finished, it goes to sleep \circled{3} and the scheduler resumes T1. If T1 sleeps as well, the idle thread will be executed. The idle has the lowest priority and will always run when all threads are suspended. 

Preemptive scheduling is the default for most RTOS because in an embedded system, priorities can be assigned based on real-time criticality. A phase current measurement handler for example is more critical than updating a graphical user interface on a display.

\subsubsection{Round-Robin (Time-Slicing)}

If two or more threads run with the same priority, they cannot preempt each other. To still share the CPU, the threads can take turns.

\begin{figure}[H]
    \centering
    \subfile{images/sched-time-sliced.tex}
    \caption{Round-robin scheduling / time slicing.}
    \label{fig:round-robin}
\end{figure}

\autoref{fig:round-robin} shows three threads with the same priority. A thread (T1) is run at max one system tick. After one tick \circled{1}, the scheduler switches to the next thread (T2). A thread can also voluntarily yield the CPU \circled{2}. The scheduler then switches to the next thread (T3) \circled{3} that cannot run for a full time-slice because the system tick triggers a thread switch.

RTOSs apply different approaches to time-slicing, in FreeRTOS, it can be enabled or disabled for all priorities \cite{amazon:freertos} while in Azure RTOS time-slicing can be controlled per thread \cite{microsoft:azure-rtos}.

The kernel enables time-slicing for all threads by default in the kernel, but it can be disabled in the Cargo manifest.

%...............................................................................
\subsection{Thread States}

Scheduling threads strictly follows the finite state machine shown in \autoref{fig:thread-fsm}.

\begin{figure}[htb!]
    \centering
    \includegraphics{thread-sm.pdf}
    \caption[Thread finite state machine]{Thread finite state machine; number within state: number of threads allowed in this state; red switch icon: thread switch out, blue switch icon: thread switch in.}
    \label{fig:thread-fsm}
\end{figure}

A thread can have one of five states:
\begin{description}
    \item[Ready] The thread is ready and waiting for a time slot to run on the CPU. This is the default state after a thread is spawned.
    
    \item[Running] There can always be exactly one thread running per CPU core. On a context switch, the running thread is moved to its new state (red switch icon) according to its transition flag and the highest priority thread is moved from ready to running (blue switch icon). The only way for a thread to enter the running state is through the ready state. If no thread is ready to run, the idle thread will be executed.
    
    \item[Sleeping] If the running thread requests to be suspended until a point in time, it will be placed in the sleeping state.
    
    \item[Blocked] If the thread requests to be suspended until an event occurs, it will be placed in the blocked state.
    
    \item[Terminated] A thread can exit by choice or when it triggers an exception (i.e., memory protection violation). In the current implementation, a terminated thread cannot be launched again. In a future implementation, the user should be able to choose the behavior upon thread termination.
\end{description}

On a microcontroller, a thread typically cycles through suspended to ready, then running and back to the suspended state because a thread often runs periodically (waiting of wake-up time) or asynchronically (waiting for an event).

The thread finite state machine is not explicitly programmed, but is rather the implicit behavior within the scheduler. The states are represented by doubly-linked lists shown in \autoref{fig:thread-list} and events are programmed in different sections in the scheduler (e.g., context switch, timer tick, event fire).

\begin{figure}[htb!]
    \centering
    \includegraphics{thread-list.pdf}
    \caption[Thread list in the scheduler]{Thread list in the scheduler (event list omitted, see \autoref{fig:event-list}).}
    \label{fig:thread-list}
\end{figure}

For a scheduler to work efficiently, it must keep context switches as short as possible. A doubly linked list with head and tail pointer is used to push an element to a list quickly. Multiple ready lists with decreasing priority lists minimize the search time for the ready thread with the highest priority. The list of sleeping threads is sorted by wake-up time to avoid having to look through all threads. The event list (separately shown in \autoref{fig:event-list}) is again sorted by priority to shorten context switch times. If threads have the same priority, the order is based on first come, first served.

Minimizing the number of priorities in an RTOS application is important, because for every priority, a ready list is be allocated and searched for a ready thread on every context switch. The time to find a ready thread depends on its priority. But it can be determined deterministically. In the worst case, the lowest priority thread will be exchanged with another lowest priority ready thread. That will take twice the time to look through $n$-priorities list heads (once to push the running thread to a ready list and once to pop the highest priority ready thread).

Using multiple doubly linked lists is a common approach to manage threads as done in \ucos-III, Zephyr and FreeRTOS \cite{amazon:freertos}. Only Zephyr offers alternative data structures such as red-black tree to manage many threads \cite{linux:zephyr}.

%...............................................................................
\subsection{Context Switch}

The context of a thread consists of any volatile information that is specific to one thread, e.g.
\begin{itemize}[nosep]
    \item CPU registers
    \item Floating-point registers
    \item Memory access configuration
\end{itemize}

On a function call, interrupt or exception the hardware pushes/pops some registers from/to the stack. In cooperative scheduling, a thread exits its entry function every time, thus stacking is completely done in hardware. However, if a thread should be preempted before it finished, some registers must be stored in software.

Because the number of registers to be stored in software depends on the hardware, a context switch is partially done in assembly in the architecture-specific implementation and the selection of the next thread is done in Rust.

\begin{figure}[htb!]
    \centering
    \includegraphics{context-switch.pdf}
    \caption{Context Switch on a CPU with Armv7E-M architecture.}
    \label{fig:context-switch}
\end{figure}

\autoref{fig:context-switch} illustrates a context switch triggered by \mintinline{rust}{sleep} call on an Arm Cortex-M4F (Armv7E-M) core. The stack pointer decreases as the stack grows, i.e., a lower stack pointer in the figure refers to more stack being used.

The thread is not allowed to change its own wake-up time, so it makes a system call using the SuperVisor Call (SVC) instruction. The \mintinline{C}{SVCall} exception has the highest priority behind system faults and will be called exactly after the \mintinline{C}{SVC} instruction \cite[~330]{yiu_beckmann_2014}. Triggering the exception will cause the CPU to push \circled{1} the exception stack frame (R0-R3, R12, Link Register (LR), Program Counter (PC), Program State Register (xPSR) and S0-S15 if the floating-point unit is used) to thread A stack. The stack pointer is switched to the main stack pointer and to handler mode automatically. The system call \circled{2} has now full access and can set the threads wake-up time, the transition flag to \mintinline{C}{Sleeping} and trigger a pendable service (PendSV) call. The PendSV exception is set to a low priority by the kernel, so that time-critical interrupts can run before the context switch is complete. The PendSV handler first stores \circled{3} the remaining registers (R4-R11, S16-S31 if the floating-point unit is used) to the thread stack in software.

The handler then calls the \mintinline{rust}{switch_thread} function from the generalized Rust implementation of kernel. The function stores the current stack pointer of the thread and chooses the next thread according to the scheduling algorithm \circled{4}. From the next thread, it loads the stack pointer and adjusts the memory protection settings. The new stack pointer is returned to the PendSV handler.

The handler pops \circled{5} the registers pushed in software and returns from the exception. The CPU now pops \circled{6} exception stack frame and continues thread B \circled{7} where it left of. \cite[~339]{yiu_beckmann_2014}

%-------------------------------------------------------------------------------
\section{Inter-Process Communication (IPC)}

Without communication, a thread can use resources moved to the stack. A peripheral could only be used by one thread throughout the application runtime, and no event could trigger an action. Thus, to create a useful application, inter-process communication is essential.

IPC in computer systems is used to transfer information beyond the virtual address space of a process \cite[~3]{tanenbaum_bos_2015}. While threads on microcontrollers share the same address space and direct access to other thread stacks would be possible, IPC is used where memory protection isolates memory. Furthermore, can common terminology, known from computer systems, be applied to embedded systems.

\begin{figure}[htb!]
    \centering
    \includegraphics{ipc-overview.pdf}
    \caption{Overview of available IPC mechanisms.}
    \label{fig:ipc-overview}
\end{figure}

Depending on the size of the information, different forms of communication are used, i.e., large measurement sample arrays need a different form of IPC than simply waiting for an event flag to be set. \autoref{fig:ipc-overview} shows an overview of the different IPC mechanisms in Bern RTOS.

%...............................................................................
\subsection{Critical Sections (internal)}

The simplest solution for synchronized access to a resource is a critical section. Before a protected resource is accessed, all interrupts are disabled. Without interrupts, no thread switch or preemption in general can occur, synchronizing access to the resource. As soon as the resource is not used anymore, interrupts can be enabled again.

The advantage of this approach is that it can be applied to any microcontroller. But disabling interrupts increases the latency of service routines that might not even affect the protected resource. In real-time application (e.g., motor control) interrupt latency must be kept low. Some CPU architectures allow for interrupt masking instead of disabling all interrupts \cite[~265]{yiu_beckmann_2014}, so that time-critical interrupts can still be executed.

Bern RTOS discourages the use of critical sections. They are not available to users. Generally, synchronization using atomic operations is preferred. Short critical sections are used within the scheduler where hardware capabilities for atomic operation do not suffice.

In the current kernel implementation, all interrupts are disabled during a critical section. This will be changed to interrupt masking when interrupt handling is added to the kernel.

%...............................................................................
\subsection{Event System (internal)}

All forms of IPC transport data between threads and allow threads to wait for an event. While the data transport is different for every form of IPC, suspending threads until data is ready, is used for all IPC. Bern RTOS uses a common event system for all IPC.

A thread can request to be suspended until an IPC is updated. On update events, the affected threads must be woken up.

\begin{figure}[htb!]
    \centering
    \includegraphics{event-list.pdf}
    \caption{Event list.}
    \label{fig:event-list}
\end{figure}

As illustrated in \autoref{fig:event-list} all events are stored in one list. An event is created for every form of IPC registered in the kernel. An event consists of the following:
\begin{description}
    \item[Identifier (ID)] Is used to access an event through a system calls. In contrast to passing a pointer to an event through system calls looking for an ID is computationally more expensive, but it ensures that a thread cannot crash the kernel by passing any memory address.
    
    \item[Settings] Contain additional information on whether to use priority inversion or if all threads should be woken-up or just the first one.
    
    \item[Pending] A list of threads pending for the event. The list sorted by priority as the highest priority thread will be granted access to the IPC first.
\end{description}

The event system is used within the kernel and the user cannot access it directly.

%...............................................................................
\subsection{Mutual Exclusion (Mutex)}

Printing to a serial interface on a microcontroller from two threads without synchronization leads to interfering strings at the output. The same happens if an array of measurement samples is read and written from different threads. Consistent data can only be guaranteed if only ever one thread can access data at a time. Mutual exclusion (mutex) is a synchronization primitive that restricts access to a resource to one thread.

%...............................................................................
\subsubsection{Design}

Similar to the \mintinline{rust}{Mutex} type from the Rust standard library, a mutex in Bern RTOS encapsulates a resource, tightly coupling synchronization and resource.

\begin{figure}[htb!]
    \centering
    \includegraphics{mutex-memory.pdf}
    \caption{Mutex data structure.}
    \label{fig:mutex-memory}
\end{figure}

A mutex has the data structure shown in \autoref{fig:mutex-memory}. It has an event ID from the event system, a lock, and data with a generic type and size. A mutex must be placed in a shared memory region for multiple threads to have access.

When a thread wants to access a mutex, it will try setting the lock using an atomic operation. If the lock can be set, the data can be accessed without ever calling the kernel. When the lock is already set a thread can be suspended until the lock is released. An event is triggered whenever a lock is released.

%...............................................................................
\subsubsection{Usage}

Using a mutex in Bern RTOS is almost equivalent to a mutex from the Rust standard library on a computer.

\begin{customlisting}
\begin{minted}[escapeinside='']{rust}
#[entry]
fn main() -> ! {
    /*..*/
    PROC.init(move |c| {
        let shared_data = Arc::new(Mutex::new(42_u32'\circled{1}'));
        let shared_data_gen = shared_data.clone();
        Thread::new(c)
            .stack(Stack::try_new_in(c, 2048).unwrap())
            .spawn(move || {
                let mut counter = 0;
                loop {
                    match shared_data_gen.lock(u32::MAX)'\circled{2}' {
                        Ok(mut value) => { *value = counter;'\circled{3}' }
                        Err(_) => {}
                    }
                    counter += 1;
                    sleep(500);
                }'\circled{4}'
            });
        /*..*/
    }).unwrap();
    /*..*/
}
\end{minted}
\caption{Creating and accessing a mutex.}
\label{lst:mutex}
\end{customlisting}

At \circled{1} in \autoref{lst:mutex} a mutex encapsuling an integer is created. The mutex only synchronizes access to a resource. It must be placed somewhere all participating threads have access. Using \mintinline{rust}{Arc} the mutex and the contained resource are allocated in process memory. Alternatively, a mutex could be allocated statically. Currently, the kernel does not support this to avoid lazy initialization.

When \mintinline{rust}{lock()} at \circled{2} is called, the thread tries setting the lock and is suspended if the mutex is already locked. The lock either returns the value encapsulated in the mutex \circled{3} or an error if for example the lock request is timed out. The mutex is automatically unlocked when the value goes out of scope \circled{4}.

\notebox{
    Timeouts are not implemented. Hence, the timeout value is ignored and a \mintinline{rust}{lock()} will block the thread until the resource is free. Alternatively, \mintinline{rust}{try_lock()} will never block.
}

%...............................................................................
\subsection{Semaphore}

An end switch on a machine might be wired to a hardware interrupt on a microcontroller. Hitting the end switch will trigger an ISR, which then must somehow communicate to the thread in charge that the machine should be stopped. A counting semaphore can be used to synchronize an interrupt event and a thread, or to synchronize multiple threads.

%...............................................................................
\subsubsection{Design}

A counting semaphore is almost identical to a mutex, but it does not hold any data. Instead of a lock, a semaphore has a given number of permits it can issue. If no permits are available a thread can be suspended until at least one permit is present. The semaphore also uses atomic operations to count permits.

%...............................................................................
\subsubsection{Usage}

The semaphore API is based on \mintinline{rust}{tokio::sync::Semaphore} \cite{tokio:tokio} and is similar to a mutex.

\begin{customlisting}
\begin{minted}[escapeinside='']{rust}
#[entry]
fn main() -> ! {
    /*..*/
    PROC.init(move |c| {
        let signal = Arc::new(Semaphore::new(0)'\circled{1}');
        let signal_sender = signal.clone();

        Thread::new(c)
            .stack(Stack::try_new_in(c, 2048).unwrap())
            .spawn(move || {
                loop {
                    match signal.acquire(u32::MAX)'\circled{2}' {
                        Ok(permit) => {
                            permit.forget();'\circled{3}'
                            do_something();
                        },
                        Err(_) => {}
                    }
                }
            });

        InterruptHandler::new(c)
            .stack(InterruptStack::Kernel)
            .connect_interrupt(stm32f4xx_hal::interrupt::EXTI15_10 as u16)
            .handler(move |_c| {
                button.clear_interrupt_pending_bit();
                signal_sender.add_permits(1);'\circled{4}'
            });
    }).unwrap();
    /*..*/
}
\end{minted}
\caption{Creating and accessing a semaphore.}
\label{lst:semaphore}
\end{customlisting}

A semaphore is created with zero permits at \circled{1} in \autoref{lst:semaphore}. The semaphore must like a mutex, be placed in process memory. \mintinline{rust}{acquire()} requests a permit in a blocking manner \circled{2}. As the initial semaphore count is zero, the thread will be suspended until a permit is added to the semaphore. Once the thread can continue, it executes a function and in this case, forgets \circled{3} the permits. Meaning that the permit will not be returned to the semaphore and the overall number of available permits will be reduced by one.

At \circled{4} an interrupt triggered by an external hardware interrupt will add one permit to the semaphore and trigger the event system waking-up the thread.

%...............................................................................
\subsection{Channel (Message Queue)}

A mutex synchronizes access to a shared resource. For example a ISR might write data received from UART interface into a shared data buffer. A thread would then poll and process the shared buffer. From this approach, two problems arise. First the ISR cannot write to the buffer when thread already locked it. Secondly, the thread always accesses the buffer to check for new data. As this use case is event based and we want to run the ISR and thread asynchronically, a message queue is a better choice.

%...............................................................................
\subsubsection{Design}

A message queue in Rust is called a channel. It consists of a data queue and management objects for the sender and receiver. In the current implementation, the data queue can store a fixed number of objects of the same type. The type and size have to be set at compile time. The data queue and hence all channels are first in first out (FIFO).

Generally, a channel copies an element to the data queue. In the case of a large object, an element can also move the ownership of an object on the heap. A few variants of the message queues exist for different use cases. One case is the communication between threads in one process, as depicted in \autoref{fig:queue-threads}.

\begin{figure}[htb!]
    \centering
    \includegraphics{queue-threads}
    \caption{Channel between threads within one process.}
    \label{fig:queue-threads}
\end{figure}

The data queue is allocated at process initialization and stored on the heap. A thread can send an element by copying it into the queue. The receiving thread can copy elements asynchronically from the queue. Hence, every element is copied twice. Copying is less efficient than passing references but simplifies the queue implementation. The data queue does not need to know how long and element is used for if it just copied to the consumer.

There is also a slight variation in whether there are one or multiple producers. A single producer single consumer (SPSC) queue is much more straightforward and thus faster than a multi producer single consumer (MPSC) queue.

Threads have access to the entire process memory. Thus, the producer can check itself whether there is a free element to copy data into. The kernel only has get involved when the producer or the consumer wants to wait for a queue event.

Another variant of channel is used to communicate across process boundaries. \autoref{fig:queue-proc} shows a thread sending a message from one process to another.

\begin{figure}[htb!]
    \centering
    \includegraphics{queue-proc}
    \caption{Channel between threads of different processes.}
    \label{fig:queue-proc}
\end{figure}

In this case the data queue is allocated statically on the consumers heap. The producer thread can make a system call to request an element to be copied to the receiving queue. The receiving thread can then access the data queue directly.

%...............................................................................
\subsubsection{Usage}

Message queues follow the terminology used by \mintinline{rust}{std::sync::mpsc::Channel} from the Rust standard library.

\begin{customlisting}
\begin{minted}[escapeinside='']{rust}
#[entry]
fn main() -> ! {
    /*..*/
    PROC.init(move |c| {
        #[link_section=".process.my_process"]
        static CHANNEL: Channel<ConstQueue<u32, 16>> = sync::spsc::channel();'\circled{1}'
        let (tx, rx) = CHANNEL.split();'\circled{2}'

        Thread::new(c)
            .stack(Stack::try_new_in(c, 2048).unwrap())
            .spawn(move || {
                let mut counter = 0;
                loop {
                    tx.send(counter).unwrap();'\circled{3}'
                    counter += 1;
                    sleep(500);
                }
            });

        Thread::new(c)
            .stack(Stack::try_new_in(c, 2048).unwrap())
            .spawn(move || {
                loop {
                    match rx.recv() '\circled{4}'{
                        Ok(v) => process(*v'\circled{5}'),
                        Err(_) => {}
                    }
                    sleep(10);
                }
            });
    }).unwrap();
    /*..*/
}
\end{minted}
\caption{Creating and accessing a channel within one process.}
\label{lst:channel}
\end{customlisting}

In this example, a channel is created at \circled{1} in \autoref{lst:channel}. The channel contains a queue that can take 16 elements of the \mintinline{rust}{u32}. Like all static data we must place it into process memory by specifying the link section. A channel is then split into sender and receiver \circled{2}.

The sender is moved to one thread that in this case periodically adds an element to the queue \circled{3}. The \mintinline{rust}{send()} method returns an error if the queue is full.

Another thread is on the receiving end of the channel \circled{4}. If there is an element in the queue, the software processes the newest element \circled{5}.

Sending data between threads of different processes uses a slightly different syntax.

\begin{customlisting}
\begin{minted}[escapeinside='']{rust}
static PROC_A: &Process = bern_kernel::new_process!(process_a, 8192);
static PROC_B: &Process = bern_kernel::new_process!(process_b, 4096);
#[entry]
fn main() -> ! {
    /*..*/
    #[link_section=".process.process_b"]
    static IPC_CHANNEL: ConstQueue<u32, 16> = ConstQueue::new();'\circled{1}'

    let channel = sync::ipc::spsc::channel();
    let (ipc_tx, ipc_rx) = channel.split(&IPC_CHANNEL'\circled{2}').unwrap();

    PROC_A.init(move |c| {
        Thread::new(c)
            .stack(Stack::try_new_in(c, 2048).unwrap())
            .spawn(move || {
                let mut counter = 0;
                loop {
                    ipc_tx.send(counter).unwrap();'\circled{3}'
                    counter += 1;
                    sleep(500);
                }
            });
    }).unwrap();

    PROC_B.init(move |c| {
        Thread::new(c)
            .stack(Stack::try_new_in(c, 2048).unwrap())
            .spawn(move || {
                loop {
                    match ipc_rx.recv() '\circled{4}'{
                        Ok(v) => process(*v),
                        Err(_) => {}
                    }
                    sleep(10);
                }
            });
    }).unwrap();
    /*..*/
}
\end{minted}
\caption{Creating and accessing a channel from one process to another.}
\label{lst:channel-ipc}
\end{customlisting}

In \autoref{lst:channel-ipc} at \circled{1} the queue behind the channel is allocated statically inside the receiving process memory. The queue is linked to the channel when splitting the channel \circled{2}. In contrast to channels within one process, this is done outside a process context.

The sender and receiver are then moved to the respective processes and threads. Sending \circled{3} and receiving \circled{4} elements through the channel is equivalent to channels inside one process.


\notebox{
    Currently Bern RTOS does not support awaiting queueing events.
}


%-------------------------------------------------------------------------------
\section{System Log}

The system log provides real-time information about the events inside the kernel at different severity levels. Additionally, the user can use the same log interface as well. Log messages give developers insight into application faults and can trace their origin. For example, if the user forgets to register an interrupt handler, the kernel will still log an interrupt event.

\subsection{Design}

The log API is split into front-end and back-ends. The front-end macros format messages, and the back-ends transport the messages to a host system. The system log was designed with the following requirements in mind:

\begin{enumerate}[nosep]
    \item Use a global logger with static function calls (the log back-end does not have to be known in a module).
    \item Tag message severity (trace, debug, info, warning and error).
    \item Filter messages by severity and module at compile time.
    \item Abstract message transport so that the log is technology independent.
\end{enumerate}

The kernel supports message formatting on the target using the standard library. As the log front-end the \mintinline{text}{log} facade \cite{github:log} is used. The library provides a lightweight logging facade commonly used in Rust. The user can the implement or use an existing log back-end. The log facade supports message filtering at compile and run-time.

If the impact on performance from string formatting on the target is too excessive, \mintinline{text}{defmt} \cite{github:defmt-test} offers an alternative. The library defers formatting to the host and uses efficient binary transport. However, \mintinline{text}{defmt} requires the symbol file of the firmware binary and an application running to host to interpret the messages.

\subsection{Usage}

Activating system logs consists of three parts: enabling logs in the kernel, selecting a front-end and back-end (transport).

\begin{customlisting}
\listingpath{[project]/Cargo.toml}
\begin{minted}[escapeinside=||]{toml}
# log facade
bern-kernel = { version = "0.3", features = ["log-global"|\circled{1}|] }
log = "0.4"
rtt-target = { version = "0.3", features = ["cortex-m"] }
# or defmt
bern-kernel = { version = "0.3", features = ["log-defmt"|\circled{2}|] }
defmt = "0.3"
defmt-rtt = "0.3" # transport using RTT
\end{minted}
\caption{Cargo log dependency.}
\label{lst:cargo-log}
\end{customlisting}

In this example, the log facade is enabled at \circled{1} in \autoref{lst:cargo-log}. The log facade is added as dependency and as a method transport real-time transfer (RTT) is used. Using defmt \circled{2} is very similar to the log facade.

Depending on the log front-end in use, some implementation is needed by the user. For the log facade, a trait must be implemented as documented in \cite{github:log}. When using defmt an additional linker script is introduced to the build process \cite{github:defmt}.

\begin{customlisting}
\listingpath{[project]/main.rs}
\begin{minted}[escapeinside='']{rust}
use bern_kernel::log::{warn, info, error};'\circled{1}'

fn main() -> ! {
    /*..*/
    warn!("Process {} is out of memory.", &proc_name);'\circled{2}'
    /*..*/
}
\end{minted}
\caption{Log usage on application level.}
\label{lst:log-example}
\end{customlisting}

In the example in \autoref{lst:log-example} the re-exported log macros from the front-end are included at \circled{1}. Log messages can then be created using the macros \circled{2}.

Keep in mind that formatting messages on the target requires stack space. Look out for stack overflow warning from the kernel when first activating logs in the application.

\autoref{lst:log-example-output} contains an example log output showing messages from the kernel and the user application. The log was printed in the host command line using \mintinline{rust}{probe-run}.

\begin{customlisting}
\begin{minted}[escapeinside='']{text}
'\textbf{\color{green}{INFO}}'  Starting Bern RTOS interrupt example. (main)
'\textbf{\color{bfhgrey}{TRACE}}' Try to allocate 2B at 0x20002000 (bern_kernel::alloc::bump)
'\textbf{\color{bfhgrey}{TRACE}}' Try to allocate 84B at 0x200012a0 (bern_kernel::alloc::bump)
'\textbf{\color{blue}{DEBUG}}' Staring kernel. (bern_kernel::kernel)
'\textbf{\color{bfhgrey}{TRACE}}' IRQ 40 called. (bern_kernel::sched)
'\textbf{\color{green}{INFO}}'  Button pressed. (main)
\end{minted}
\caption{Example log output.}
\label{lst:log-example-output}
\end{customlisting}


%------------------------------------------------x------------------------------
\section{System Tracing}

System logs provide insight about the events in the application and kernel. Log messages require processing power on the target to be transmitted and rarely provide precise timing information. System tracing, on the other hand gives event information with little overhead. Simple tracing can be performed using digital signal on an output pin and a measurement device. Using a separate software tool and a stream of trace data provides a detailed view of thread interaction.

\subsection{Design}

The kernel uses a tracing abstraction so that the user can select a tracing back-end of choice. The dependencies of the tracing library are illustrated in \autoref{fig:tracing-deps}.

\begin{figure}[htb!]
    \centering
    \includegraphics{tracing-deps.pdf}§
    \caption{Tracing library dependencies.}
    \label{fig:tracing-deps}
\end{figure}

A kernel component such as the scheduler uses the static tracing functions. Then, the tracing library calls the functions from the tracing back-end. However, the tracing back-end is an unknown dependency at the time the tracing library is compiled. To overcome this issue, function shims and extern functions are used. A function shim simply calls the corresponding external function.

The set of tracing functions is defined in the \mintinline{rust}{RtosTracing} trait. A tracing back-end (e.g. SystemView) is required to completely implement the trait. With the help of a macro the extern functions are generated. Therefore, the dependency from the tracing library is now resolved at link time instead of compile time. A similar method is used for Rusts global allocator.

\begin{figure}[H]
    \centering
    \begin{overpic}[abs,width=\linewidth,percent,frame]{systemview}
        \put(35,38){\color{red}\circled{1}}
        \put(85,38){\color{red}\circled{2}}
        \put(28,18){\color{red}\circled{3}}
        \put(48,6){\color{red}\circled{4}}
    \end{overpic}
    \caption{SEGGER SystemView application.}
    \label{fig:systemview-screenshot}
\end{figure}

An example system trace is visualized using SEGGER SystemView in \autoref{fig:systemview-screenshot}. The application shows an event trace \circled{1}, log messages \circled{2}, a scheduling timeline \circled{3} and usage statistics \circled{4}.

%...............................................................................
\subsection{Usage}

Tracing is an integral part of the kernel. All tracing calls are already in place. 

\begin{customlisting}
\listingpath{[project]/Cargo.toml}
\begin{minted}[escapeinside=||]{toml}
bern-kernel = { version = "0.3", features = ["tracing"|\circled{1}|] }
rtos-trace = "0.1"|\circled{2}|
systemview-target|\circled{3}|=  { version = "0.1", features = ["cortex-m", "callbacks-os"|\circled{4}|, "callbacks-os-time"] }
\end{minted}
\caption{Cargo tracing dependency.}
\label{lst:cargo-tracing}
\end{customlisting}

In order to use them the user has to activate kernel tracing as shown at \circled{1} in \autoref{lst:cargo-tracing}. Then the user has to select a tracing back-end. The tracing traits and macros are included at \circled{2} and the as SystemView \circled{3} is selected as tracing back-end.

In case of Bern RTOS the kernel supports some callbacks from the tracing software to provide system information. The callbacks are activated at \circled{4}.

\begin{customlisting}
\listingpath{[project]/main.rs}
\begin{minted}[escapeinside='']{rust}
use systemview_target::SystemView;
rtos_trace::global_trace!{SystemView}'\circled{1}'
static TRACE: systemview_target::SystemView = systemview_target::SystemView::new();'\circled{2}'

fn main() -> ! {
    TRACE.init();'\circled{3}'
    /*..*/
}
\end{minted}
\caption{Cargo tracing dependency.}
\label{lst:tracing-systemview}
\end{customlisting}

In the user application, the external functions are generated with the macro at \circled{1} in \autoref{lst:tracing-systemview}. The only left is to statically allocate \circled{1} and initialize \circled{3} the tracing back-end.

%-------------------------------------------------------------------------------
\section{Memory Allocation}

Multiple memory allocation schemes for different use cases exist. In safety critical systems memory is often allocated statically. Hence, the compiler can guarantee that there is memory for an object before the application is loaded onto the target.

In an application with graphics there are many short lived objects for drawing a GUI. Here, dynamic memory allocation can make better use of the available memory. Objects only require memory as long when used and do not block unnecessary memory.

Bern RTOS supports multiple allocation schemes so that the user can choose the one that fits the requirements. Multiple allocators can be used in one application because each process has its own heap memory.

%...............................................................................
\subsection{Process Allocator}

Bern RTOS supports Rust container types (\mintinline{rust}{Box}, \mintinline{rust}{Arc}, etc.) by implementing the required global allocator. The RTOS selects the right process allocator based on runtime information. The sequence for an allocation is illustrated in \autoref{fig:alloc-sequence}.

\begin{figure}[htb!]
    \centering
    \includegraphics{alloc-sequence.pdf}
    \caption{Allocation sequence diagram from inside a process.}
    \label{fig:alloc-sequence}
\end{figure}

First the GUI thread makes an allocation request using \mintinline{rust}{boxed::Box::new(...)} from Rusts \mintinline{rust}{alloc} library. The library then calls the global allocator implemented in the kernel. From there, with a system call, the program switches into kernel mode so that it can access the kernel internals. The global allocator then requests the allocator from the currently running process. The memory block is then allocated and the system call ends. Finally, the global allocator returns a block a memory to the allocator, which returns a type safe object to the thread.

\notebox{
    At the moment the bump allocator is the default for all processes. Other allocators are not yet available for processes.

    The new \mintinline{text}{allocator_api} \cite{rust:allocator_api} will allow the user to select an allocator for every object, i.e. \mintinline{rust}{Box::try_new_in(42, MyAllocator)}. The new allocator API will be supported as soon as the feature is stabilized.
}

%...............................................................................
\subsection{Bump Allocator}

A bump allocator provides memory in a fast and deterministically. Its implementation is simple because a bump allocator cannot free memory. \cite{phil-opp:allocator}

\autoref{fig:alloc-bump} illustrates the bump allocator over time. 

\begin{figure}[htb!]
    \centering
    \includegraphics{alloc-bump.pdf}
    \caption{Bump allocator memory view.}
    \label{fig:alloc-bump}
\end{figure}

The management structure contains a pointer to a block of memory used for the allocation. Initially the pointer is at the base of the block. Whenever a thread requests memory, the pointer address increases accordingly. Denoted in grey are areas which are wasted due to alignment. When \emph{C} is allocated it the pointer address again increments according to the request size.

In the last column \emph{B} is deallocated. This scenario should never occur as the bump allocator cannot free memory. Hence, the allocator pointer does not change its position and \emph{B}s memory block goes to waste. The allocator logs a warning whenever a deallocation attempt is made. Thanks to its simplicity, the bump allocator is lock free.

\notebox{
    As the bump allocator never frees memory all memory request are known at compile time. They could be replaced by a static variable. A static allocation has the advantage that an out of memory exception is caught at compile time. However, static memory must be initialized statically. This is an issue because for example a mutex needs an ID from the kernel. In that case, the user must declare the mutex statically and then request initialization from the kernel. There is a chance that the user forgets the second step and the mutex has no valid ID. To overcome this issue, lazy initialization could be used where the mutex is initialized on the first call. However, that introduces runtime overhead from the initialization checks.

    Because of to separation of the kernel and application memory for there are at least two variables for every kernel object. For example, a thread has a stack in application code, but the thread table entry is in kernel memory. Thus, static allocation for a thread is a little more complicated than with a conventional RTOS. In the long term, the goal is to replace the bump allocator with static allocations to provide stronger guaranties at compile time.
}


%...............................................................................
\subsection{Heap Allocator}

In a dynamic system with many short lived variables static allocation might not fit into memory. A heap can allocate memory for variables and free the memory block at the end of the variables lifetime. 

The heap allocator in Bern RTOS uses a free-list and is based on \cite{phil-opp:allocator}. The memory view over time is shown in \autoref{fig:alloc-heap}.

\begin{figure}[htb!]
    \centering
    \includegraphics{alloc-heap.pdf}
    \caption{Free-list based heap allocator memory view.}
    \label{fig:alloc-heap}
\end{figure}

At the beginning, the free-list just contains one node. The node stores the size of the free block and the pointer to the next block. After some time, there might be some holes between variables with longer lifetimes. The second column in \autoref{fig:alloc-heap} shows two free nodes in the list. The nodes are sorted in an ascending order to allow for block merging.

When the application requests memory for \emph{C} the allocator searches the free-list for the first large enough free block. There is some memory left after \emph{C} is allocated. The allocator places a new node in that free block.

After some time, the lifetime of \emph{B} ends and the application request deallocation of its memory. First, a new node is placed in \emph{B}s place. The node is then sorted into the free-list. As a last step, the allocator checks if there is one or more adjacent free blocks and merges them.

Merging free blocks reduces memory fragmentation drastically, but does not completely resolve the issue. A heap works well as long as all variables remain in scope for a similar amount of time. If there are a few long living and some very short lived variables more and more holes will prevent efficient memory usage.

Concerning functional safety, note that heap allocation is \emph{not} deterministic. The number of free nodes varies greatly at runtime and so does the search time for a free memory block. 

\notebox{
    The current implementation can only merge blocks with ascending addresses. Memory fragments very quickly. Therefore, the heap cannot be selected as allocator strategy for the moment.
}

%...............................................................................
\subsection{Memory Pool}

The memory pool or fixed block allocator is an attempt on a deterministic and fast heap. It combats fragmentation by allocating fixed blocks of memory. \cite[~279]{labrosse_2009}

\autoref{fig:alloc-pool} illustrates a memory pool over time.

\begin{figure}[htb!]
    \centering
    \includegraphics{alloc-pool.pdf}
    \caption{Memory pool allocator memory view.}
    \label{fig:alloc-pool}
\end{figure}

An empty memory pool consists of multiple partitions with free memory blocks. There is a free-queue for each partition. After some time, the order of the nodes in the free-queue can change. Note that variables are mostly not a perfect fit and leave some unused space in the memory block (grey).

When the application requests memory for \emph{D} the allocator looks through the partition table for the first partition with a large enough and free block. The search is fast and has bounded execution time because there are a constant number of partitions. If a partition fits the requirements, the first block is popped from the queue.

Deallocating a variable (in this case \emph{D}) is straightforward. In its deallocation request, the application passes the address of \emph{D}. The pool allocator then checks which partition the address belongs to. Finally, a free node is pushed to the back of the partition.

The free-queue is implemented atomically. Thus, the allocation is lock-free and interrupts do not need to be disabled.


%-------------------------------------------------------------------------------
\section{Memory Protection}

For a system to be safe and secure, caution must be taken while designing and implementing software. But that is not sufficient, runtime checks are needed as protection from attacks or software bugs. Strict memory access control can only be enforced in hardware. Bern RTOS aims to abstract memory protection hardware and provide a generic solution to protect memory regions. In addition, the kernel was designed for process isolation from the start.

%...............................................................................
\subsection{Design}

The granularity of memory protection regions is much dependent on the hardware. Memory protection currently only supports the Armv7E-M architecture and was tested on an Arm Cortex-M4 core. The hardware abstraction used in Bern RTOS is partially based on \cite{verhaert:mpu} in which an architecture-agnostic memory protection for Tock OS was developed.

\begin{figure}[htb!]
    \centering
    \includegraphics{memory-protection.pdf}
    \caption{Memory protection seen from thread X.}
    \label{fig:memory-protection}
\end{figure}

An example memory protection configuration seen from thread X is shown in \autoref{fig:memory-protection}. The thread has access to everything within its parent process. The kernel is responsible for placing variables captured by the thread closure on the stack. Some microcontrollers have a dedicated stack overflow prevention mechanism, some use a memory region. Either way, some hardware to \emph{prevent} stack overflow must be present.

The kernel uses the main stack and can never be accessed from any thread directly. Isolating the kernel is crucial, as all system and thread management data could be manipulated otherwise. System calls provide an isolation barrier between threads and the kernel. A system call contains a service ID for a given request and arguments. A call triggers an exception switching to the kernel. The arguments can then be checked before the kernel processes the call with the highest privileges. Setting up a system call, parameter verification and processing takes longer than accessing the data structure directly. In the case of the kernel, execution overhead is justified by increased security.

A little bit looser is the protection on the peripherals. Here, constant copying of data is too much overhead and most microcontrollers do not have memory protection, which can adjust to regions of arbitrary size. Thus, the all-or-nothing approach applies, either a thread can access all shared memory or it cannot. Depending on the hardware in use, some peripherals can be excluded from general access permissions or multiple shared memory regions can be defined for groups of threads.


%...............................................................................
\subsection{Usage}

Memory protection is heavily based on linker sections and symbols. These symbols are hidden from the user in the macro used to create a new process. Further linker sections are created based on the configuration in the \mintinline{rust}{bern-config} crate.

\begin{customlisting}
\begin{minted}[escapeinside='']{c}
SECTIONS {
    .process_my_process'\circled{1}' : ALIGN(4096)
    {
        /* Process static memory */
        . = ALIGN(8);
        __smprocess_my_process = .;
        KEEP(*(.process.my_process'\circled{2}'))
        . = ALIGN(8);
        __emprocess_my_process = .;

        /* Process heap */
        . = ALIGN(8);
        __shprocess_my_process = .;
        . = __smprocess_my_process + 4096;'\circled{3}'
        __ehprocess_my_process = .;

        ASSERT(/*..*/);'\circled{4}'
    } > RAM'\circled{5}' AT> FLASH
    __siprocess_my_process = LOADADDR(.process_my_process);
} INSERT AFTER .shared_global;
\end{minted}
\caption{Linker script extract for a process.}
\label{lst:process-linker-script}
\end{customlisting}

Invoking \mintinline{rust}{bern_kernel::new_process!(my_process, 4096)} generates the linker script extract shown in \autoref{lst:process-linker-script}. The macro creates a new linker section \circled{1} and alignment required by the hardware. Each process section can place static data inside the process using the process name \circled{2}. The rest of the process memory is available to the process allocator. Setting an end of section symbol \circled{3} ensures that the linker section has a fixed size. The kernel uses the start and end symbols to initialize the static data and the allocator.

If the static data is larger than the available process memory, the assertion \circled{4} will throw an error at link time. The process memory is placed in the volatile memory selected in the RTOS configuration and initialization in flash.

%-------------------------------------------------------------------------------
\section{Configuration}

An RTOS kernel has many settings to adjust the performance for a particular system. Consider a low power system running at 72 MHz with little RAM (e.g. 32 kB). There is no need for memory allocation or structures to store hundreds of threads. However, on a high performance microcontroller running 480 MHz, external memory and lots of interface the additional code size from allocation is not an issue.

\subsection{Design}

The kernel configuration consists of parameterizing internals, enabled optional modules and providing information about the hardware. Bern RTOS heavily relies on memory protection and linker sections to place static variables into process memory. As the kernel does not depend on microcontroller hardware specifics, the user has to provide memory layout information in the configuration.

An RTOS in C is typically configured using a header file. The preprocessor symbols are global during the build process. For example number of priorities is defined in the configuration header file in the user application and directly applied to the kernel.

In Rust those global symbols do not exist. One solution is to use constant generics in structures. For example, we could then set the number of priorities to 8 in the user application \mintinline{rust}{static SCHED: Scheduler<8> = Scheduler::new();}. At the moment, const generics can only take primitive types. For some parameters strong types are preferred. Another solution is to use environment variables in the build shell. This approach suffers from weak types even more.

There are many more solutions to this problem. For simplicity reason the kernel uses a cargo patch in the build process.

\begin{figure}[htb!]
    \centering
    \includegraphics{conf-deps.pdf}
    \caption{Kernel configuration dependencies.}
    \label{fig:conf-deps}
\end{figure}

The bern-kernel crate in \autoref{fig:conf-deps} depends on the default \emph{bern-conf} crate implementation. On the application, the bern-conf crate is implemented again and passed as a patch to the build system. Thus, there are no circular dependencies. More importantly, the build command is still \mintinline{rust}{cargo build} and does not require any external tools.

In addition to detailed adjustments in the configuration crate, some modules can be disabled altogether. System logs and tracing are not necessary for every application. These features are optional and configurable in the cargo manifest.

%...............................................................................
\subsection{Usage}

The API documentation lists the kernel features to enable optional modules. Configuring the memory layout and kernel parameters are done in the configuration crate.

\begin{customlisting}
\listingpath{[project]/conf/conf.rs}
\begin{minted}[escapeinside='']{rust}
    pub const'\circled{1}'CONF: Conf<1> = Conf {
        kernel: Kernel {'\circled{2}'
            priorities: 8, 
            memory_size: Byte::from_kB(2),
        },
    
        shared: Shared  {'\circled{3}'
            size: Byte::from_kB(8),
        },
    
        memory_map: MemoryMap'\circled{4}'{
            flash: Memory {
                link_name: "FLASH",
                start_address: 0x0800_0000,
                size: Byte::from_MB(1),
            },
            sram: Memory {
                link_name: "RAM",
                start_address: 0x2000_0000,
                size: Byte::from_kB(512),
            },
            peripheral: Memory {
                link_name: "",
                start_address: 0x4000_0000,
                size: Byte::from_MB(512),
            },
            additional:'\circled{5}'[
                OptionalMemory {
                    memory_type: MemoryType::Ram,
                    location: MemoryLocation::External,
                    link_name: "XRAM",
                    start_address: 0xC000_0000,
                    size: Byte::from_MB(32),
                }
            ],
        },
    
        data_placement: DataPlacement {'\circled{6}'
            kernel: "RAM",
            processes: "RAM",
            shared: "RAM"
        }
    };
\end{minted}
\caption{Bern RTOS memory configuration.}
\label{lst:rtos-conf}
\end{customlisting}

The configuration is a constant structure \circled{1} in \autoref{lst:rtos-conf}. The kernel can use those constants to define the sizes of the static variables. First up is the kernel configuration \circled{2}. Here, we set the number of priorities and the size of the kernel RAM region. Static variables in the kernel and heap are present in the that region.

The shared region \circled{3} will be accessible by all threads and processes. Sharing data with all parts of the application is undesirable. However, some libraries contain static data which are not placed in any process memory.

The memory map configuration \circled{4} requires three regions and can contain optional regions. Required are flash, RAM and peripheral regions. The kernel sets up default memory access based on those regions. If a microcontroller offers special RAM or if there are external flash, RAM, or memory-mapped peripherals, additional \circled{5} memory regions can be defined.

Lastly, the user can select the memory component where data will be placed \circled{6}. Often, this will be set to RAM.

